Codeforces 789D Weird journey - 欧拉路 - 图论

Little boy Igor wants to become a traveller. At first, he decided to visit all the cities of his motherland — Uzhlyandia.

It is widely known that Uzhlyandia has n cities connected with m bidirectional roads. Also, there are no two roads in the country that connect the same pair of cities, but roads starting and ending in the same city can exist. Igor wants to plan his journey beforehand. Boy thinks a path is good if the path goes over m - 2 roads twice, and over the other 2 exactly once. The good path can start and finish in any city of Uzhlyandia.

Now he wants to know how many different good paths are in Uzhlyandia. Two paths are considered different if the sets of roads the paths goes over exactly once differ. Help Igor — calculate the number of good paths.

Input

The first line contains two integers nm (1 ≤ n, m ≤ 106) — the number of cities and roads in Uzhlyandia, respectively.

Each of the next m lines contains two integers u and v (1 ≤ u, v ≤ n) that mean that there is road between cities u and v.

It is guaranteed that no road will be given in the input twice. That also means that for every city there is no more than one road that connects the city to itself.

Output

Print out the only integer — the number of good paths in Uzhlyandia.

Examples

input

5 41 21 31 41 5

output

6

input

5 31 22 34 5

output

0

input

2 21 11 2

output

1

Note

In first sample test case the good paths are:

  • 2 → 1 → 3 → 1 → 4 → 1 → 5,
  • 2 → 1 → 3 → 1 → 5 → 1 → 4,
  • 2 → 1 → 4 → 1 → 5 → 1 → 3,
  • 3 → 1 → 2 → 1 → 4 → 1 → 5,
  • 3 → 1 → 2 → 1 → 5 → 1 → 4,
  • 4 → 1 → 2 → 1 → 3 → 1 → 5.

There are good paths that are same with displayed above, because the sets of roads they pass over once are same:

  • 2 → 1 → 4 → 1 → 3 → 1 → 5,
  • 2 → 1 → 5 → 1 → 3 → 1 → 4,
  • 2 → 1 → 5 → 1 → 4 → 1 → 3,
  • 3 → 1 → 4 → 1 → 2 → 1 → 5,
  • 3 → 1 → 5 → 1 → 2 → 1 → 4,
  • 4 → 1 → 3 → 1 → 2 → 1 → 5,
  • and all the paths in the other direction.

Thus, the answer is 6.

In the second test case, Igor simply can not walk by all the roads.

In the third case, Igor walks once over every road.



  题目大意 给定一个有n个顶点和m条边的无向图,问有多少条路径使得恰好(m - 2)条边被经过2次,2条边恰好被经过1次。两条路径被看做不同的,当且仅当它们经过的边的集合不同。

  原问题可以转换为将每条边复制一下,然后再删去两条边使得新图存在欧拉路的方案数。

  欧拉路存在的两个条件是

  1)只存在一个连通块包含的边数大于0

  2)度数为奇数的点少于2个。

  暂时先不考虑自环的情况,然后可以得到一个结论就是:这两条边的必须存在公共顶点。

  然后可以得到一个做法就是枚举每个点,计算和它相连的边中,任选两条的方案数。

  现在考虑自环,删掉一个自环使得这个顶点的度数仍然为偶数,所以选取的一条边包含自环,那么另一条边可以任意选。

  为了更好地计数,暂时不把自环算入度数,最后统一计算。然后会出现选择的两条边都是自环被计算2次的情况,所以减一减就好了。

Code

 1 /**
 2  * Codeforces
 3  * Problem#789D
 4  * Accepted
 5  * Time: 421ms
 6  * Memory: 37400k
 7  */
 8 #include <bits/stdc++.h>
 9 #ifndef WIN32
10 #define Auto "%lld"
11 #else
12 #define Auto "%I64d"
13 #endif
14 using namespace std;
15 typedef bool boolean;
16
17 int n, m;
18 int *dag;
19 int* f;
20 int scc = 0;
21 boolean *haveedge;
22
23 int find(int x) {
24     return (f[x] == x) ? (x) : (f[x] = find(f[x]));
25 }
26
27 inline void init() {
28     scanf("%d%d", &n, &m);
29     dag = new int[(n + 1)];
30     f = new int[(n + 1)];
31     haveedge = new boolean[(n + 1)];
32     memset(dag, 0, sizeof(int) * (n + 1));
33     for(int i = 1; i <= n; i++)
34         f[i] = i, haveedge[i] = false;
35     for(int i = 1, u, v; i <= m; i++) {
36         scanf("%d%d", &u, &v);
37         dag[u] += u != v, dag[v] += u != v;
38         haveedge[u] = haveedge[v] = true;
39         scc += u == v;
40         f[find(u)] = find(v);
41     }
42 }
43
44 long long res = 0;
45 int cnt = 0;
46 inline void solve() {
47     for(int i = 1; i <= n; i++) {
48         res += (dag[i] * 1LL * (dag[i] - 1)) >> 1;
49         cnt += f[i] == i && haveedge[i];
50     }
51     printf(Auto"\n", (cnt == 1) ? (res + (scc * 1LL * (m - 1)) - ((scc * 1LL * (scc - 1)) >> 1)) : (0));
52 }
53
54 int main() {
55     init();
56     solve();
57     return 0;
58 }
时间: 2024-11-02 23:06:14

Codeforces 789D Weird journey - 欧拉路 - 图论的相关文章

图论--欧拉路,欧拉回路(小结)

在题目中在慢慢细说概念 1.HDU - 3018 Ant Trip 题目大意:又N个村庄,M条道路,问需要走几次才能将所有的路遍历 解题思路:这题问的是有关欧拉路的判定 欧拉路就是每条边只能走一次,且要遍历所有的边,简单的说就是一笔画(图连通) 这道题是无向图的欧拉路,无向图的欧拉路的判定:所有点的度数都是偶数度,或者只有两个点的度是奇数度,且图要是连通图 知道欧拉路是什么后,这题就比较好做了,第一件事就是找到有几个连通块,然后再判断一下每个连通块需要几笔才能完成就好了 #include <cs

poj 1386 Play on Words(有向图欧拉路+并查集)

题目链接:http://poj.org/problem?id=1386 思路分析:该问题要求判断单词是否能连接成一条直线,转换为图论问题:将单词的首字母和尾字母看做一个点,每个单词描述了一条从首字母指向尾字母的有向边, 则则所有的单词构成了一个有向图,问题变为判断该有向图中是否存在一条欧拉路:有向图中存在欧拉路的两个充分必要条件为:该图是联通的并且所有的点的入度等于出度或者只存在两个点的入度与出度不等,一个点的入度=出度+1,另一个点的入度=出度-1: 代码如下: #include <cstdi

POJ 2337 欧拉路

Catenyms Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 11214   Accepted: 2908 Description A catenym is a pair of words separated by a period such that the last letter of the first word is the same as the last letter of the second. For

CodeForces 789D 欧拉路径计数,思维

CodeForces 789D 题意:n个点m条边的无向图,求经过其中m-2条边两次,剩下2条边一次的方案数有几种,如果剩下两条边的集合一样算同一种. tags: 选出两条边,其它m-2条边假想复制成两条,这样就是要求欧拉路径是否存在,即奇点个数是否为0或2. 所以该怎么选这两条边呢? 先把边分为自环边和普通边. 1.选取两条不相邻普通边,图中存在4个奇点,不满足欧拉路径条件: 2.选取两条相邻普通边,图中存在2个奇点,满足欧拉路径条件: 3.选取一条普通边一条自环,图中存在2个奇点,满足欧拉路

HDU5883 The Best Path(并查集+欧拉路)

题意: n个点m条边,问m条边构成的是否为欧拉路. 是的话输出路径上所有点的异或和,每个点经过几次异或几次. 思路: 先用并查集判断是否连通,然后如果是欧拉路的话有两种情况 如果奇数度节点有2个,就枚举这两个点做起点,选大的 如果都为偶数度节点,就枚举n个起点,选大的 /* *********************************************** Author :devil ************************************************ *

CCF 201512-4 送货 (并查集+DFS,欧拉路)

问题描述 为了增加公司收入,F公司新开设了物流业务.由于F公司在业界的良好口碑,物流业务一开通即受到了消费者的欢迎,物流业务马上遍及了城市的每条街道.然而,F公司现在只安排了小明一个人负责所有街道的服务. 任务虽然繁重,但是小明有足够的信心,他拿到了城市的地图,准备研究最好的方案.城市中有n个交叉路口,m条街道连接在这些交叉路口之间,每条街道的 首尾都正好连接着一个交叉路口.除开街道的首尾端点,街道不会在其他位置与其他街道相交.每个交叉路口都至少连接着一条街道,有的交叉路口可能只连接着一 条或两

欧拉路

欧拉路径和欧拉回路欧拉路径:从某结点出发一笔画成所经过的路线叫做欧拉路径.欧拉回路:在欧拉路径的基础上又回到起点.a.凡是由偶点组成的连通图,一定可以一笔画成.画时可以把任一偶点为起点,最后一定能以这个点为 终点画完此图. b.凡是只有两个奇点的连通图(其余都为偶点),一定可以一笔画成.画时必须把一个奇点为起点,另 一个奇点终点. c.其他情况的图都不能一笔画出.(有偶数个奇点除以2便可算出此图需几笔画成.) 欧拉回路和欧拉路径的判断欧拉回路:无向图:每个顶点的度数都是偶数,则存在欧拉回路.有向

图的路径:欧拉路(欧拉回路)

欧拉路的相关概念: 1.能从无向图中的一个顶点出发,并走出一条道路,每条边恰好经过一次,这样的路线就叫做欧拉路: 2.找欧拉路首先要判断是否存在欧拉路: 一个无向图存在欧拉路当且仅当该图是连通的,且有且只有0或2个点的度数是奇数,为2时这两个点只能作为欧拉路径的起点和终点(0个时称为欧拉回路). 3.确定存在欧拉路之后,开始构造欧拉路: 欧拉路参考:http://blog.csdn.net/shahdza/article/details/6630108 等做完题,再来补充.

POJ 2513--Colored Sticks【字典树编号 &amp;&amp; 并查集判连通 &amp;&amp; 欧拉路】

Colored Sticks Time Limit: 5000MS   Memory Limit: 128000K Total Submissions: 32351   Accepted: 8536 Description You are given a bunch of wooden sticks. Each endpoint of each stick is colored with some color. Is it possible to align the sticks in a st